/***************************************************************************
                          ctxdisplay.h  -  description
                             -------------------
    begin                : Sun Sep 17 2000
    copyright            : (C) 2000 by Volker Schroer
    email                : DL1KSV@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *   based on the work of Moe Wheatley, AE4JY                              *
 ***************************************************************************/

#ifndef CTXDISPLAY_H
#define CTXDISPLAY_H

#include <qwidget.h>
#include <qframe.h>
#include <qlabel.h>
#include <qradiobutton.h>
#include <qspinbox.h>
#include <qpushbutton.h>
#include "ctxwindow.h"
#include "crxselect.h"
#include "cledbutton.h"
/**Txdisplay including control elements
  *@author Volker Schroer
  */



class CTxdisplay : public QFrame  {
   Q_OBJECT
public: 
	CTxdisplay(QWidget *parent=0, const char *name=0);
	~CTxdisplay();
	 CTxwindow *txwindow;
	 int getTxFrequency();

 /** Start Receiving /Transmitting */
	 CLedButton *start;
 /** Selecting Rx- Window */
 	CRxSelect *SelectRxWindow;


private:
// Tx Parameters
 QGroupBox *transmit;
 QRadioButton *bnet;
 QSpinBox *txfreq;
 int txfrequency;				//TX frequency


protected:
	void resizeEvent(QResizeEvent *);
	
public slots:
void changetxfreq(int);	

	
};

#endif
