/***************************************************************************
                          ctxwindow.h  -  description
                             -------------------
    begin                : Sun Mar 5 2000
    copyright            : (C) 2000 by Volker Schroer
    email                : DL1KSV@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *   based on the work of Moe Wheatley, AE4JY                              *
 ***************************************************************************/

#ifndef CTXWINDOW_H
#define CTXWINDOW_H



#include <qmultilineedit.h>
#include <qkeycode.h>
#include <qapplication.h>
#include <qbuttongroup.h>
#include <ctype.h>
#include "constants.h"
#include  "parameter.h"

extern Parameter settings;

/**TX Window
  *@author Volker Schroer
  */

class CTxwindow : public QMultiLineEdit  {
  Q_OBJECT
public:
	CTxwindow(QWidget *parent=0, const char *name=0);
	~CTxwindow();
	void setMaxLine(int count=0);
	void setMaxVisible(int count=0);
	int getTxChar(void);
	int insertTxChar(const char *,int);
	void insertCntrlChar(int);
	bool TxBufferisEmpty();
private:
	int maxline;
	int visible;
	int akt_line;
	int akt_col;
	int txbuffer[TXBUFFER_LENGTH];
  unsigned int inpos;
	unsigned int outpos;
	unsigned int filled;
protected:
	void keyPressEvent(QKeyEvent *e);
signals:
	
};

#endif
